import java.lang.*;
import java.util.Arrays;

//--------------------------------------------------------------------//
/**
 * tBONX
 */
public class Morph extends Deform{

  public Morph(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * C[W̃sNZf[^Ԃ
 * @param t }p[^ (0 ` 1 ͈̔)
 * @param morphImg1 C[W 1
 * @param morphImg2 C[W 2
 * @return sNZf[^i[z
 */
  protected int[] getPixel(double t,MorphImage morphImg1,
      	      	      	   MorphImage morphImg2){
    int bgColor=mixedColor(t,morphImg1.getBackground(),
      	      	      	   morphImg2.getBackground());
    int pixel[]=new int[width*height];
    Arrays.fill(pixel,bgColor);
    int figureHeight=Math.max(morphImg1.getFigureHeight(),
      	      	      	      morphImg2.getFigureHeight());
    double ddy1=(double)morphImg1.getFigureHeight()
      	       /(double)figureHeight;
    double ddy2=(double)morphImg2.getFigureHeight()
      	       /(double)figureHeight;

    for(int j=0;j<figureHeight;j++){
      double dy1=ddy1*(double)j;
      double dy2=ddy2*(double)j;
      int j1=(int)dy1;
      int j2=(int)dy2;
      int y1=morphImg1.getFigureY(j1);
      int y2=morphImg2.getFigureY(j2);
      dy1+=(double)(y1-j1);
      dy2+=(double)(y2-j2);
      int ofs=width*inter(t,dy1,dy2);
      int dx=Math.max(morphImg1.getFigureWidth(y1),
      	      	      morphImg2.getFigureWidth(y2));
      double ddx1=(double)morphImg1.getFigureWidth(y1)/(double)dx;
      double ddx2=(double)morphImg2.getFigureWidth(y2)/(double)dx;
      for(int i=0;i<dx;i++){
      	double dx1=ddx1*(double)i;
      	double dx2=ddx2*(double)i;
      	int i1=(int)dx1;
      	int i2=(int)dx2;
      	int x1=morphImg1.getFigureX(i1,y1);
      	int x2=morphImg2.getFigureX(i2,y2);
      	dx1+=(double)(x1-i1);
      	dx2+=(double)(x2-i2);
      	int ii=ofs+inter(t,dx1,dx2);
      	pixel[ii]=mixedColor(t,morphImg1.pixel(x1,y1),
      	      	      	     morphImg2.pixel(x2,y2));
      }
    }
    return pixel;
  }
}
