import java.awt.Color;
import java.awt.Image;
import java.awt.image.ImageObserver;
import java.awt.image.PixelGrabber;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * ό`C[WNX
 */
public class MorphImage{

/** C[W̕ */
  protected int width;

/** C[W̍ */
  protected int height;

/** ʃsNZi[z */
  protected int pixel[];

/** ό`Ώۂ <i>x</i> W */
  protected int figureX[];

/** ό`Ώۂ <i>y</i> W */
  protected int figureY[];

/** ό`Ώۂ̕ */
  protected int figureWidth[];

/** ό`Ώۂ̍ */
  protected int figureHeight;

/** sNZItZbg */
  protected int ofset[];

/** wiF */
  protected Color bgColor;

/**
 * ό`C[WIuWFNg̍\z
 * @param image sNZf[^oC[W
 * @param width C[W̕
 * @param height C[W̍
 * @param threshold wiF臒l
 */
  public MorphImage(Image image,int width,int height,int threshold){
    this.width=width;
    this.height=height;
    pixel=getPixel(image,width,height);
    init(threshold);
  }

//--------------------------------------------------------------------//
/**
 * C[WsNZf[^o
 * @param image sNZf[^oC[W
 * @param width C[W̕
 * @param height C[W̍
 * @return sNZf[^i[z
 */
  protected int[] getPixel(Image image,int width,int height){
    int pixel[]=new int[width*height];
    PixelGrabber pg=new PixelGrabber
      (image,0,0,width,height,pixel,0,width);
    try{
      pg.grabPixels();
    }
    catch(InterruptedException ex){
      System.out.println("grabber error "+ex.toString());
    }
    if(pg.status()==ImageObserver.ABORT){
      System.out.println("grabber error");
    }
    return pixel;
  }

//--------------------------------------------------------------------//
/**
 * sNZf[^̏
 * @param threshold wiF臒l
 */
  protected void init(int threshold){
    figureX=new int[(width+1)*height];
    figureY=new int[height+1];
    figureWidth=new int[height];
    ofset=new int[height+1];

    int thres2=threshold*threshold;
    bgColor=new Color(pixel[0]);
    int ii=0;
    int jj=0;
    figureHeight=0;
    ofset[0]=0;
    for(int j=0;j<height;j++){
      int kk=0;
      for(int i=0;i<width;i++){
      	Color color=new Color(pixel[ii]);
      	int dr=color.getRed()-bgColor.getRed();
      	int dg=color.getGreen()-bgColor.getGreen();
      	int db=color.getBlue()-bgColor.getBlue();
      	int dist=dr*dr+dg*dg+db*db;
      	if(dist>=thres2){
      	  figureX[jj]=i;
      	  jj++;
      	  kk++;
      	}
      	ii++;
      }
      if(kk!=0){
      	figureY[figureHeight]=j;
      	figureHeight++;
      	figureX[jj]=figureX[jj-1]+1;
      	jj++;
      }
      figureWidth[j]=kk;
      ofset[j+1]=jj;
    }
    figureY[figureHeight]=figureY[figureHeight-1]+1;
  }

//--------------------------------------------------------------------//
/**
 * C[W̕Ԃ
 * @return C[W̕
 */
  public int getWidth(){
    return width;
  }

//--------------------------------------------------------------------//
/**
 * C[W̍Ԃ
 * @return C[W̍
 */
  public int getHeight(){
    return height;
  }

//--------------------------------------------------------------------//
/**
 * sNZf[^Ԃ
 * @param x <i>x</i> W
 * @param y <i>y</i> W
 * @return w肳ꂽʒũsNZf[^
 */
  public int pixel(int x,int y){
    return pixel[width*y+x];
  }

//--------------------------------------------------------------------//
/**
 * ό`Ώۂ <i>x</i> WԂ
 * @param indexX ό`Ώۂ <i>x</i> WoCfbNX
 * @param y C[W <i>y</i> W
 * @return w肳ꂽʒu̕ό`Ώۂ <i>x</i> W
 */
  public int getFigureX(int indexX,int y){
    return figureX[ofset[y]+indexX];
  }

//--------------------------------------------------------------------//
/**
 * ό`Ώۂ <i>y</i> WԂ
 * @param index ό`Ώۂ <i>y</i> WoCfbNX
 * @return w肳ꂽʒu̕ό`Ώۂ <i>y</i> W
 */
  public int getFigureY(int index){
    return figureY[index];
  }

//--------------------------------------------------------------------//
/**
 * ό`Ώۂ̕Ԃ
 * @param y C[W <i>y</i> W
 * @return ό`Ώۂ̕
 */
  public int getFigureWidth(int y){
    return figureWidth[y];
  }

//--------------------------------------------------------------------//
/**
 * ό`Ώۂ̍Ԃ
 * @return ό`Ώۂ̍
 */
  public int getFigureHeight(){
    return figureHeight;
  }

//--------------------------------------------------------------------//
/**
 * wiFԂ
 * @return wiF
 */
  public int getBackground(){
    return bgColor.getRGB();
  }
}
