import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.lang.*;
import java.net.URL;
import java.util.ArrayList;

//--------------------------------------------------------------------//
/**
 * tBO CNX
 * @author aG
 * @version 1.1
 */
public class Morphing extends Applet implements Runnable{

/** C[W̐ */
  protected int imageCount;

/** C[Wi[z */
  protected MorphImage mimg[];

/** ό`\IuWFNg */
  protected Deform deform;

/** ݂̃Xebv */
  protected int time=0;

/** 1Xebv̎ (~b) */
  protected int dtime;

/** ό`OC[W̃|C^ */
  protected int image1=0;

/** ό`C[W̃|C^ */
  protected int image2=1;

/** ό`̊Ԃ̑҂ (~b) */
  protected int waitTime;

/** ό`ɗv鎞 (~b) */
  protected int morphTime;

/** ό`̃Xebv */
  protected int step;

/** wiF臒l */
  protected int threshold;

/** \XVXbh */
  protected Thread viewThread=null;

//--------------------------------------------------------------------//
/**
 * Avbg
 */
  public void init(){
    setBackground(Color.BLACK);
    getParameter();
    getPixelData();
  }

//--------------------------------------------------------------------//
/**
 * \[Xj
 */
  public void destroy(){
    removeAll();
  }

//--------------------------------------------------------------------//
/**
 * Aj[VJn
 */
  public void start(){
    if(viewThread==null){
      viewThread=new Thread(this);
      viewThread.start();
    }
  }

//--------------------------------------------------------------------//
/**
 * Xbhs
 */
  public void run(){
    synchronized(this){
      while(viewThread!=null){
      	time++;
      	repaint();
      	if(time==step){
      	  if(imageCount>=2){
      	    image1=(image1+1)%imageCount;
      	    image2=(image2+1)%imageCount;
      	  }
      	  time=0;
      	  sleep(waitTime);
      	}
      	else{
      	  sleep(dtime);
      	}
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * Aj[V~
 */
  public void stop(){
    viewThread=null;
  }

//--------------------------------------------------------------------//
/**
 * sꎞ~
 * @param waitTime s~ (~b)
 */
  protected void sleep(int waitTime){
    try{
      viewThread.sleep(waitTime);
    }
    catch(InterruptedException ex){
      System.out.println(ex);
    }
  }

//--------------------------------------------------------------------//
/**
 * p[^ǂݍ
 */
  protected void getParameter(){
    waitTime=getNumber("waitTime",2000);
    morphTime=getNumber("morphTime",2000);
    step=getNumber("step",10);
    threshold=getNumber("threshold",40);
    String deformType=getParameter("MDswitch");
    if(deformType==null){
      deform=new Morph();
    }
//    else if(deformType.toLowerCase().equals("morphing")){
//      deform=new Morph();
//    }
    else if(deformType.toLowerCase().equals("dissolving")){
      deform=new Dissolve();
    }
    else{
      deform=new Morph();
    }
    dtime=morphTime/step;
  }

//--------------------------------------------------------------------//
/**
 * sNZf[^ǂݍ
 */
  protected void getPixelData(){
    ArrayList imageList=new ArrayList();
    imageCount=0;
    String name=null;
    do{
      name=getParameter("image"+(imageCount+1));
      if(name!=null){
      	imageList.add(name);
      	imageCount++;
      }
    }while(name!=null);
    String imageNames[]=new String[imageCount];
    for(int i=0;i<imageCount;i++){
      imageNames[i]=(String)imageList.get(i);
    }

    Image images[]=getImages(imageCount,imageNames);
    mimg=new MorphImage[imageCount];
    for(int i=0;i<imageCount;i++){
      int width=images[i].getWidth(this);
      int height=images[i].getHeight(this);
      mimg[i]=new MorphImage(images[i],width,height,threshold);
    }
  }

//--------------------------------------------------------------------//
/**
 * lf[^擾
 * @param name f[^
 * @param defaultValue l̃ftHgl
 * @return lf[^
 */
  protected int getNumber(String name,int defaultValue){
    String s=getParameter(name);
    if(s==null) return defaultValue;
    try{
      return Integer.parseInt(s);
    }
    catch(NumberFormatException ex){
    }
    return defaultValue;
  }

//--------------------------------------------------------------------//
/**
 * C[Wǂݍ
 * @param imageName C[W̃t@C
 * @return ǂݍ񂾃C[W
 */
  protected synchronized Image getImage(String imageName){
    URL url=getClass().getResource(imageName);
    if(url==null){
      System.out.println(imageName+" can not find");
      return null;
    }
    else{
      Image image=getImage(url);
      MediaTracker tracker=new MediaTracker(this);
      tracker.addImage(image,0);
      try{
      	tracker.waitForAll();
      }
      catch(InterruptedException ex){
      	System.out.println(ex);
      }
      return image;
    }
  }

//--------------------------------------------------------------------//
/**
 * C[Wǂݍ
 * @param imageCount ǂݍރC[W̐
 * @param imageNames C[W̃t@Ci[z
 * @return ǂݍ񂾃C[Wi[z
 */
  protected synchronized Image[] getImages
    (int imageCount,String imageNames[]){
    imageCount=Math.min(imageCount,imageNames.length);
    Image images[]=new Image[imageCount];
    MediaTracker tracker=new MediaTracker(this);
    Class cl=getClass();
    for(int i=0;i<imageCount;i++){
      URL url=cl.getResource(imageNames[i]);
      if(url==null){
      	System.out.println(imageNames[i]+" can not find");
      }
      else{
      	images[i]=getImage(url);
      	tracker.addImage(images[i],i);
      }
    }
    try{
      tracker.waitForAll();
    }
    catch(InterruptedException ex){
      System.out.println(ex);
    }
    return images;
  }

//--------------------------------------------------------------------//
/**
 * C[W쐬
 */
  protected Image calculateImage(){
    if(imageCount<2) return null;
    return createImage(deform.getImageSource((double)time/step,
      	      	       mimg[image1],mimg[image2]));
  }

//--------------------------------------------------------------------//
/**
 * ĕ`悷
 * @param g `悷OtBbNXReLXg
 */
  public void update(Graphics g){
    Image image=calculateImage();
    if(image!=null) g.drawImage(image,0,0,null);
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  public void paint(Graphics g){
    Image image=calculateImage();
    if(image!=null) g.drawImage(image,0,0,null);
  }

//--------------------------------------------------------------------//
/**
 * AvbgԂ
 * @return Avbg܂ޕ
 */
  public String getAppletInfo(){
    return "Applet of morphing and dissolving\n"
      	  +"Author K.Higuchi";
  }

//--------------------------------------------------------------------//
/**
 * ̃Avbg߂p[^Ԃ
 * @return Avbg߂p[^i[z
 */
  public String[][] getParameterInfo(){
    String info[][]=
     {{"waitTime","int","Between deforming time. Default is 2000"},
      {"morphTime","int","Deform time. Default is 2000."},
      {"step","int","Deform step number. Default is 10."},
      {"threshold","int","Backgroung color threshold. Default is 40."},
      {"MDswitch","String","Deform type. Default is morphing"}};
    return info;
  }
}
